package com.eneraptor.hci

class LogicRequestController {

	def reportService
	def hciLogicCommService
	
    def testConnection = {
		
		def output = "";
		output += reportService.println("Conection test using")
		output += reportService.println("Logic IP address: " + InternalConfig.findByConfigId('logic-ip').configVal)
		output += reportService.println("Logic port number: " + InternalConfig.findByConfigId('logic-port').configVal)
		
		output += reportService.println("Test started")
		
		String reqStr = "<?xml version=\"1.0\"?><hci-request type=\"checkConnection\"><data>12345</data></hci-request>"
		Map testReply = hciLogicCommService.getReplyToRequest(reqStr)
		
		if(testReply['status'] == "error") {
			output += reportService.println("<span style='color:red;'>Error: " + testReply['content'] + "</span>")
		} else {
			output += reportService.println("Connection established succesfully")
			if(testReply['content'] == "<logic-response type=\"checkConnection\"><data>12345</data></logic-response>") {
				output += "<span style='color:green;'>Logic unit replied! The eneraptor system is set up properly.</span>"
			} else {
				output += reportService.println("<span style='color:red;'>The connection was established, but there was no reply from the logic unit.</span>")
				output += reportService.println("<span style='color:red;'>You should check the logic's port number and IP address.</span>");
				output += reportService.println("<span style='color:red;'>Returned: " + testReply['content'].encodeAsHTML() + "</span>");
			}
		}
		
		output += reportService.println("Test ended")
		
		[output:output]
		
	}
	
}
